using System;

namespace Aritmetica
{
	public struct Complexo
	{
		private float r;
		private float i;

		public Complexo(float r, float i)
		{
			this.r = r;
			this.i = i;
		}

		public Complexo(Complexo o)
		{
			this.r = o.Real;
			this.i = o.Imaginaria;
		}

		public float Real
		{
			get { return r; }
			//set { r = value; }
		}

		public float Imaginaria
		{
			get { return i; }
			//set { i = value; }
		}

		public override string ToString()
		{
			return r.ToString() + i.ToString() + "i";
		}

		public static Complexo operator+(Complexo c1, Complexo c2)
		{
            return c1.Add(c2);
		}

        // sugerido pelo FxCop
        public Complexo Add(Complexo c2)
        {
            Complexo ret = new Complexo(this.Real + c2.Real, this.Imaginaria + c2.Imaginaria);
            return ret;
        }

        // sugerido pelo FxCop
        public static bool operator ==(Complexo c1, Complexo c2)
        {
            return c1.Imaginaria == c2.Imaginaria && c1.Real == c2.Real;
        }

        // obrigatorio por ter o operator==
        public static bool operator !=(Complexo c1, Complexo c2)
        {
            return c1.Imaginaria == c2.Imaginaria && c1.Real == c2.Real;
        }

        //sugerido pelo FxCop devido a operator==
        public override bool Equals(object obj)
        {
            try
            {
                Complexo c2 = (Complexo)obj;
                return this == c2;
            }
            catch (InvalidCastException /*ex*/)
            {
                return false;
            }
        }

        //sugerido pelo FxCop devido a operator==
        public override int GetHashCode()
        {
            // dummy implementation
            return base.GetHashCode();
        }
    }

	/// <summary>
	/// Summary description for IAritmeticaComplexos.
	/// </summary>
	public interface IAritmeticaComplexos
	{
        Complexo Adicao(Complexo c1, Complexo c2);
        Complexo Subtracao(Complexo c1, Complexo c2);
        Complexo Multiplicacao(Complexo c1, Complexo c2);
        Complexo Divisao(Complexo c1, Complexo c2);
	}
}
